#include "beremiz.h"
#ifndef __POUS_H
#define __POUS_H

#include "accessor.h"
#include "iec_std_lib.h"

__DECLARE_ENUMERATED_TYPE(LOGLEVEL,
  LOGLEVEL__CRITICAL,
  LOGLEVEL__WARNING,
  LOGLEVEL__INFO,
  LOGLEVEL__DEBUG
)
// FUNCTION_BLOCK LOGGER
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,MSG)
  __DECLARE_VAR(LOGLEVEL,LEVEL)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(BOOL,TRIG0)

} LOGGER;

void LOGGER_init__(LOGGER *data__, BOOL retain);
// Code part
void LOGGER_body__(LOGGER *data__);
// FUNCTION_BLOCK PYTHON_EVAL
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,CODE)
  __DECLARE_VAR(BOOL,ACK)
  __DECLARE_VAR(STRING,RESULT)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(DWORD,STATE)
  __DECLARE_VAR(STRING,BUFFER)
  __DECLARE_VAR(STRING,PREBUFFER)
  __DECLARE_VAR(BOOL,TRIGM1)
  __DECLARE_VAR(BOOL,TRIGGED)

} PYTHON_EVAL;

void PYTHON_EVAL_init__(PYTHON_EVAL *data__, BOOL retain);
// Code part
void PYTHON_EVAL_body__(PYTHON_EVAL *data__);
// FUNCTION_BLOCK PYTHON_POLL
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,CODE)
  __DECLARE_VAR(BOOL,ACK)
  __DECLARE_VAR(STRING,RESULT)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(DWORD,STATE)
  __DECLARE_VAR(STRING,BUFFER)
  __DECLARE_VAR(STRING,PREBUFFER)
  __DECLARE_VAR(BOOL,TRIGM1)
  __DECLARE_VAR(BOOL,TRIGGED)

} PYTHON_POLL;

void PYTHON_POLL_init__(PYTHON_POLL *data__, BOOL retain);
// Code part
void PYTHON_POLL_body__(PYTHON_POLL *data__);
// FUNCTION_BLOCK PYTHON_GEAR
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(UINT,N)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,CODE)
  __DECLARE_VAR(BOOL,ACK)
  __DECLARE_VAR(STRING,RESULT)

  // FB private variables - TEMP, private and located variables
  PYTHON_EVAL PY_EVAL;
  __DECLARE_VAR(UINT,COUNTER)
  __DECLARE_VAR(UINT,ADD10_OUT)
  __DECLARE_VAR(BOOL,EQ13_OUT)
  __DECLARE_VAR(UINT,SEL15_OUT)
  __DECLARE_VAR(BOOL,AND7_OUT)

} PYTHON_GEAR;

void PYTHON_GEAR_init__(PYTHON_GEAR *data__, BOOL retain);
// Code part
void PYTHON_GEAR_body__(PYTHON_GEAR *data__);
// FUNCTION_BLOCK W_TO_B_OFF
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(WORD,IN0)
  __DECLARE_VAR(BOOL,OUT)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(WORD,VAL_COMP)
  __DECLARE_VAR(BOOL,VAL0)
  __DECLARE_VAR(BOOL,OUT0)
  __DECLARE_VAR(BOOL,OUT1)

} W_TO_B_OFF;

void W_TO_B_OFF_init__(W_TO_B_OFF *data__, BOOL retain);
// Code part
void W_TO_B_OFF_body__(W_TO_B_OFF *data__);
// FUNCTION_BLOCK AND_VAR_T
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,IN0)
  __DECLARE_VAR(BOOL,IN1)
  __DECLARE_VAR(BOOL,OUT)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(BOOL,VAR0)
  __DECLARE_VAR(BOOL,VAL0)
  __DECLARE_VAR(BOOL,VAR_T)
  __DECLARE_VAR(BOOL,VAR_F)
  __DECLARE_VAR(BOOL,OUT0)
  __DECLARE_VAR(BOOL,OUT1)

} AND_VAR_T;

void AND_VAR_T_init__(AND_VAR_T *data__, BOOL retain);
// Code part
void AND_VAR_T_body__(AND_VAR_T *data__);
// FUNCTION_BLOCK W_TO_B_ON
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(WORD,IN0)
  __DECLARE_VAR(BOOL,OUT)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(WORD,VAL_COMP)
  __DECLARE_VAR(BOOL,VAL0)
  __DECLARE_VAR(BOOL,OUT0)
  __DECLARE_VAR(BOOL,OUT1)

} W_TO_B_ON;

void W_TO_B_ON_init__(W_TO_B_ON *data__, BOOL retain);
// Code part
void W_TO_B_ON_body__(W_TO_B_ON *data__);
// FUNCTION_BLOCK B_TO_W_ON_OFF
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,IN0)
  __DECLARE_VAR(BOOL,IN1)
  __DECLARE_VAR(WORD,OUT)
  __DECLARE_VAR(BOOL,OUT2)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(WORD,VAL0)
  __DECLARE_VAR(BOOL,VAL1)
  __DECLARE_VAR(BOOL,VAL2)
  __DECLARE_VAR(BOOL,VAL3)
  __DECLARE_VAR(WORD,OUT0)
  __DECLARE_VAR(WORD,OUT1)

} B_TO_W_ON_OFF;

void B_TO_W_ON_OFF_init__(B_TO_W_ON_OFF *data__, BOOL retain);
// Code part
void B_TO_W_ON_OFF_body__(B_TO_W_ON_OFF *data__);
// FUNCTION_BLOCK B_TO_W_ON
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,IN0)
  __DECLARE_VAR(WORD,OUT)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(WORD,VAL0)
  __DECLARE_VAR(WORD,OUT0)
  __DECLARE_VAR(WORD,OUT1)

} B_TO_W_ON;

void B_TO_W_ON_init__(B_TO_W_ON *data__, BOOL retain);
// Code part
void B_TO_W_ON_body__(B_TO_W_ON *data__);
// FUNCTION_BLOCK AND_VAR_F
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,IN0)
  __DECLARE_VAR(BOOL,IN1)
  __DECLARE_VAR(BOOL,OUT)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(BOOL,VAR0)
  __DECLARE_VAR(BOOL,VAL0)
  __DECLARE_VAR(BOOL,VAR_T)
  __DECLARE_VAR(BOOL,VAR_F)
  __DECLARE_VAR(BOOL,OUT0)
  __DECLARE_VAR(BOOL,OUT1)

} AND_VAR_F;

void AND_VAR_F_init__(AND_VAR_F *data__, BOOL retain);
// Code part
void AND_VAR_F_body__(AND_VAR_F *data__);
// PROGRAM PLC_TRAFFIC_UNO
// Data part
typedef struct {
  // PROGRAM Interface - IN, OUT, IN_OUT variables

  // PROGRAM private variables - TEMP, private and located variables
  __DECLARE_VAR(BOOL,STATUS)
  __DECLARE_VAR(WORD,O_LEDRED)
  __DECLARE_VAR(WORD,O_LEDORANGE)
  __DECLARE_VAR(WORD,O_LEDGREEN)
  TOF TOF0;
  B_TO_W_ON B_TO_W_ON4;
  W_TO_B_ON W_TO_B_ON0;
  F_TRIG F_TRIG0;
  F_TRIG F_TRIG2;
  W_TO_B_ON W_TO_B_ON2;
  B_TO_W_ON B_TO_W_ON5;
  TOF TOF2;
  F_TRIG F_TRIG3;
  W_TO_B_ON W_TO_B_ON3;
  TOF TOF3;
  AND_VAR_F AND_VAR_F0;
  W_TO_B_ON W_TO_B_ON4;
  B_TO_W_ON_OFF B_TO_W_ON_OFF0;
  AND_VAR_T AND_VAR_T0;
  __DECLARE_VAR(BOOL,OR63_OUT)

} PLC_TRAFFIC_UNO;

void PLC_TRAFFIC_UNO_init__(PLC_TRAFFIC_UNO *data__, BOOL retain);
// Code part
void PLC_TRAFFIC_UNO_body__(PLC_TRAFFIC_UNO *data__);
#endif //__POUS_H
